SystemOrganization addCategory: #'Steap-Core'!

ODBCResultTable subclass: #EAPConnectors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Steap-Core'!

!EAPConnectors class methodsFor: 'as yet unclassified' stamp: 'BenjaminComan 1/2/2012 01:45'!
newFromConnection: connection
	"Example:	connection := ODBCConnection dsn: 'CIM' user: '' password: ''.
				packages := EAPPackages newFromConnection: connection.
				connection close."
	
	| connectors parent |
	connectors := (connection query: 'select * from t_connector;') execute asTable.
	self adoptInstance: connectors.
	connectors do: [ :row || tmppkg | tmppkg := EAPConnector new copyFrom: row. tmppkg become: row ].
	
	^connectors. ! !

!EAPConnectors methodsFor: 'as yet unclassified' stamp: 'BenjaminComan 12/31/2011 14:40'!
generalizations
	^self select: [ :conn | conn isGeneralization ]! !

!EAPConnectors methodsFor: 'as yet unclassified' stamp: 'BenjaminComan 1/2/2012 02:20'!
generalizationsEnds
	| generalisations result |
	"EAPCache connectors generalizationsClasses"
	generalisations := self generalizations.
	result := generalisations collect: [ :conn | conn start ].
	result addAll: (generalisations collect: [ :conn | conn end ]).
	^ result asSet.! !

!EAPConnectors methodsFor: 'as yet unclassified' stamp: 'BenjaminComan 1/1/2012 02:08'!
generalizationsSortedClassNames
	| generalisations result |
	"EAPCache connectors generalizationsSortedClassNames"
	generalisations := self generalizations.
	result := generalisations collect: [ :conn | conn start name ].
	result addAll: (generalisations collect: [ :conn | conn end name ]).
	^ (result sort: [:a :c | a > c]) asSet.! !

ODBCResultTable subclass: #EAPObjects
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Steap-Core'!

!EAPObjects class methodsFor: 'as yet unclassified' stamp: 'BenjaminComan 1/1/2012 19:12'!
newFromConnection: connection
	"Example:	connection := ODBCConnection dsn: 'CIM' user: '' password: ''.
				packages := EAPPackages newFromConnection: connection.
				connection close."
	
	| objects  parent |
	objects  := (connection query: 'select * from t_object;') execute asTable.
	self adoptInstance: objects.
	objects do: [ :row || tmppkg | tmppkg := EAPObject new copyFrom: row. tmppkg become: row ].

	^objects.  ! !

!EAPObjects methodsFor: 'as yet unclassified' stamp: 'BenjaminComan 1/1/2012 00:37'!
classes 
	
	^ ( self select: [ :obj | obj isClass ] ) collect: [ :obj | obj name ].! !

!EAPObjects methodsFor: 'as yet unclassified' stamp: 'BenjaminComan 12/30/2011 01:36'!
names
	^ self collect: [ :obj | obj name].! !

ODBCResultTable subclass: #EAPPackages
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Steap-Core'!

!EAPPackages class methodsFor: 'as yet unclassified' stamp: 'BenjaminComan 1/2/2012 01:45'!
newFromConnection: connection
	"Example:	connection := ODBCConnection dsn: 'CIM' user: '' password: ''.
				packages := EAPPackages newFromConnection: connection.
				connection close."
	
	| packages parent |
	packages := (connection query: 'select * from t_package;') execute asTable.
	self adoptInstance: packages.
	packages do: [ :row || tmppkg | tmppkg := EAPPackage new copyFrom: row. tmppkg become: row ].

	^packages. ! !

!EAPPackages methodsFor: 'as yet unclassified' stamp: 'BenjaminComan 12/28/2011 14:06'!
names
	^ self collect: [ :package | package name].! !

ODBCRow subclass: #EAPConnector
	instanceVariableNames: 'start end'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Steap-Core'!

!EAPConnector methodsFor: 'accessing' stamp: 'BenjaminComan 12/31/2011 13:32'!
connectorID
	^self at: #Connector_ID.! !

!EAPConnector methodsFor: 'accessing' stamp: 'BenjaminComan 12/30/2011 01:44'!
end
	^ end! !

!EAPConnector methodsFor: 'accessing' stamp: 'BenjaminComan 12/30/2011 01:44'!
end: anObject
	end := anObject! !

!EAPConnector methodsFor: 'accessing' stamp: 'BenjaminComan 12/31/2011 14:36'!
isGeneralization
	^self type = 'Generalization' ! !

!EAPConnector methodsFor: 'accessing' stamp: 'BenjaminComan 12/31/2011 13:27'!
myhalt
	((self at: #Connector_ID) = 6) ifTrue: [self halt]! !

!EAPConnector methodsFor: 'accessing' stamp: 'BenjaminComan 12/31/2011 14:34'!
printOn: aStream

	self printNameOn: aStream.
	aStream nextPutAll: '('.
	aStream print: self connectorID.
	aStream nextPutAll: '-'.
	aStream print: self type.
	aStream nextPutAll: ':  '.
	aStream print: self start name.
	aStream nextPutAll: ' --> '.
	aStream print: (self end name).	
	aStream nextPutAll: ')'.! !

!EAPConnector methodsFor: 'accessing' stamp: 'BenjaminComan 12/30/2011 01:44'!
start
	^ start! !

!EAPConnector methodsFor: 'accessing' stamp: 'BenjaminComan 12/30/2011 01:44'!
start: anObject
	start := anObject! !

!EAPConnector methodsFor: 'accessing' stamp: 'BenjaminComan 12/31/2011 14:28'!
type
	^ self at: #Connector_Type! !

ODBCRow subclass: #EAPObject
	instanceVariableNames: 'parentPackage connectors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Steap-Core'!

!EAPObject methodsFor: 'as yet unclassified' stamp: 'BenjaminComan 1/2/2012 11:03'!
connectorAdd: aConnector
	connectors ifNil: [ connectors := Set new ].
	connectors add: aConnector.! !

!EAPObject methodsFor: 'as yet unclassified' stamp: 'BenjaminComan 1/2/2012 11:53'!
connectors
	connectors ifNil: [ connectors := Set new ].
	^connectors ! !

!EAPObject methodsFor: 'as yet unclassified' stamp: 'BenjaminComan 1/5/2012 00:24'!
id
	^ self at: #Object_ID ! !

!EAPObject methodsFor: 'as yet unclassified' stamp: 'BenjaminComan 12/31/2011 14:47'!
isClass
	^ self type = 'Class'.! !

!EAPObject methodsFor: 'as yet unclassified' stamp: 'BenjaminComan 12/30/2011 01:36'!
name
	^ self at: #Name! !

!EAPObject methodsFor: 'as yet unclassified' stamp: 'BenjaminComan 12/31/2011 12:08'!
nameIfNotNilHalt
	| myname |
	myname := self at: #Name.
	myname ifNotNil: [self halt ].
	^ myname! !

!EAPObject methodsFor: 'accessing' stamp: 'BenjaminComan 1/1/2012 19:30'!
parentPackage
	^ parentPackage! !

!EAPObject methodsFor: 'accessing' stamp: 'BenjaminComan 1/1/2012 19:30'!
parentPackage: anObject
	parentPackage := anObject! !

!EAPObject methodsFor: 'as yet unclassified' stamp: 'BenjaminComan 12/31/2011 13:31'!
printOn: aStream

	self printNameOn: aStream.
	aStream nextPutAll: '('.
	aStream print: (self at: #Name ).
	aStream nextPutAll: ')'.! !

!EAPObject methodsFor: 'as yet unclassified' stamp: 'BenjaminComan 12/31/2011 14:46'!
type
	^ self at: #Object_Type! !

ODBCRow subclass: #EAPPackage
	instanceVariableNames: 'parent items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Steap-Core'!

!EAPPackage methodsFor: 'as yet unclassified' stamp: 'BenjaminComan 1/1/2012 19:38'!
id
	^ self at: #Package_ID! !

!EAPPackage methodsFor: 'as yet unclassified' stamp: 'BenjaminComan 1/2/2012 11:05'!
itemAdd: anObject
	items ifNil: [ items := Set new].
	items add: anObject.! !

!EAPPackage methodsFor: 'as yet unclassified' stamp: 'BenjaminComan 1/2/2012 11:34'!
items
	items ifNil: [ items := OrderedCollection new ].
	^items.! !

!EAPPackage methodsFor: 'as yet unclassified' stamp: 'BenjaminComan 12/28/2011 14:06'!
name
	^ self at: #Name! !

!EAPPackage methodsFor: 'as yet unclassified' stamp: 'BenjaminComan 12/28/2011 14:26'!
parent
	^ parent! !

!EAPPackage methodsFor: 'as yet unclassified' stamp: 'BenjaminComan 12/28/2011 14:26'!
parent: aPackage
	parent := aPackage! !

!EAPPackage methodsFor: 'as yet unclassified' stamp: 'BenjaminComan 12/29/2011 03:25'!
printOn: aStream

	self printNameOn: aStream.
	aStream nextPutAll: '('.
	aStream print: (self at: #Package_ID).
	aStream nextPutAll: ', '.
	aStream print: (self at: #Name ).
	aStream nextPutAll: ' --> '.
	aStream print: (self parent name ).	
	aStream nextPutAll: ')'.! !

Object subclass: #EAPCache
	instanceVariableNames: ''
	classVariableNames: 'CachedConnectors CachedObjects CachedPackages MondrianView'
	poolDictionaries: ''
	category: 'Steap-Core'!

!EAPCache commentStamp: 'BenjaminComan 12/30/2011 01:13' prior: 0!
Just a global place to store tables read into the image.!

!EAPCache class methodsFor: 'as yet unclassified' stamp: 'BenjaminComan 1/2/2012 17:09'!
canvas
	^canvas .! !

!EAPCache class methodsFor: 'as yet unclassified' stamp: 'BenjaminComan 1/2/2012 17:09'!
canvas: aCanvas
	canvas := aCanvas.! !

!EAPCache class methodsFor: 'as yet unclassified' stamp: 'BenjaminComan 12/30/2011 01:30'!
connectors
	^CachedConnectors ! !

!EAPCache class methodsFor: 'as yet unclassified' stamp: 'BenjaminComan 12/30/2011 01:30'!
connectors: connectors
	CachedConnectors := connectors! !

!EAPCache class methodsFor: 'as yet unclassified' stamp: 'BenjaminComan 1/2/2012 11:05'!
linkAll
	"Massage data to convert foreign keys to object links"
	self linkPackageParents.      
	self linkObjectsToPackages.
	self linkConnectorEndsToObjects.
! !

!EAPCache class methodsFor: 'as yet unclassified' stamp: 'BenjaminComan 1/2/2012 11:08'!
linkConnectorEndsToObjects
	"Link start of connector based on object ID here"
	| startName endName |
	self connectors do: [ :conn || startID start | 
		( ( (startID := conn at: #Start_Object_ID) ) < 1 ) ifTrue: [ startID := 1 ].
		start := self objects detect: [ :obj | startID = ( obj at: #Object_ID ) ].
		conn start: start. 
		start connectorAdd: conn.
	].

	"Link end of connector based on object ID here"
	self connectors do: [ :conn || endID end | 
		( ( endID := conn at: #End_Object_ID ) < 1 ) ifTrue: [ endID := 1 ].
		end := self objects detect: [ :obj | endID = ( obj at: #Object_ID ) ].
		conn end: end. 
		end connectorAdd: conn.
	].

! !

!EAPCache class methodsFor: 'as yet unclassified' stamp: 'BenjaminComan 1/2/2012 11:06'!
linkObjectsToPackages
	"Link start of connector based on object ID here"
	| startName endName conn | 
	self objects do: 
		[ :obj || package | 
			package := self packages detect: 
				[ :pkg | 
					( pkg id ) = ( obj at: #Package_ID )  
				].
			obj parentPackage: package.
			package itemAdd: obj.
		].
! !

!EAPCache class methodsFor: 'as yet unclassified' stamp: 'BenjaminComan 1/2/2012 01:43'!
linkPackageParents
	"Link the parents"
	self packages do: 
		[ :package || parentID parent | 
			parentID := package at: #Parent_ID.
			( parentID < 1 ) ifTrue: 
				[ 
					parentID := 1 
				].
			parent := self packages detect: 
				[ :package2 | 
					parentID = ( package2 at: #Package_ID ).
				].
			package parent: parent.	
		].! !

!EAPCache class methodsFor: 'as yet unclassified' stamp: 'BenjaminComan 1/2/2012 11:05'!
load
	|connection|
	"Cache tables from database"
	connection := ODBCConnection dsn: 'CIM' user: '' password: ''.
	self packages: (EAPPackages newFromConnection: connection).
	self objects: (EAPObjects newFromConnection: connection).
	self connectors: (EAPConnectors newFromConnection: connection).
	connection close.

	"Massage data to convert foreign keys to object links"
	self linkAll.! !

!EAPCache class methodsFor: 'as yet unclassified' stamp: 'BenjaminComan 1/2/2012 18:24'!
mondrianView
	^MondrianView! !

!EAPCache class methodsFor: 'as yet unclassified' stamp: 'BenjaminComan 1/2/2012 18:23'!
mondrianView: aView
	MondrianView := aView.! !

!EAPCache class methodsFor: 'as yet unclassified' stamp: 'BenjaminComan 1/5/2012 00:26'!
objectWIthId: id
	^ self objects detect: [ :obj | obj id = id]
	! !

!EAPCache class methodsFor: 'as yet unclassified' stamp: 'BenjaminComan 12/30/2011 01:24'!
objects
	^CachedObjects! !

!EAPCache class methodsFor: 'as yet unclassified' stamp: 'BenjaminComan 12/30/2011 01:24'!
objects: objs
	CachedObjects := objs! !

!EAPCache class methodsFor: 'as yet unclassified' stamp: 'BenjaminComan 12/30/2011 01:21'!
packages
	^CachedPackages! !

!EAPCache class methodsFor: 'as yet unclassified' stamp: 'BenjaminComan 12/30/2011 01:21'!
packages: pkgs
	CachedPackages := pkgs! !
